<?php

require_once 'base/GepConvocadoreuniaoEntityBase.php';

/**
 * This class has been auto-generated by Setforms
 *
 * @package Entity
 *
 * @author  robertomartins
 */
class GepConvocadoreuniaoEntity extends GepConvocadoreuniaoEntityBase
{


    const SEM_REGISTRO = 10;


    /**
     * Gera novo codigo de convocado reuniao.
     *
     * @param integer $nrorg Numero da Organizacao.
     *
     * @return $codigo integer
     */
    public static function retornaProxNumeroConvocadoreuniao($nrorg){
        $codigo = Novocodigo::geraCodigo($nrorg, 'GEP_CONVOCADOREUNIAO', 10);
        return $codigo;
    }


    /**  ok
     * Retorna dados do convocado por reuniao.
     *
     * @param integer $reuniao Numero da reuniao.
     * @param integer $nrorg   Numero da organizacao.
     *
     * @throws Exception Caso nao contenha convocados para esta reuniao.
     *
     * @return Ambigous <Ambigous, boolean, NULL, TkModelEntity>
     */
    public static function consultaConvocadosPorReuniao ($reuniao ,$nrorg) {
        $dados = GepConvocadoreuniao::consultaConvocadoReuniaoByReuniao($reuniao, $nrorg);

        if (count($dados) > 0) {
            return $dados;
        }

        throw new Exception('GepConvocadoreuniaoEntity: Nao ha convocados para esta reuniao', self::SEM_REGISTRO);
    }


     /**
     * Retorna dado do convocado da reuniao.
     *
     * @param integer $nrconvocadoreuniao Numero da reuniao.
     * @param integer $nrorg              Numero da organizacao.
     *
     * @return Ambigous <<type>, multitype:, mixed>|boolean
     */
    public static function consultaConvocadoReuniao ($nrconvocadoreuniao ,$nrorg) {
        $dados = GepConvocadoreuniao::consultaConvocadoReuniao($nrconvocadoreuniao, $nrorg);
        if ($dados instanceof GepConvocadoreuniaoEntity) {
            return $dados;
        }

        throw new Exception('Erro consulta convocado', self::SEM_REGISTRO);
    }


    /**
    * Exclui Convocado por Reuniao.
    *
    * @param integer $nrreuniao Numero da reuniao.
    * @param integer $nrorg     Numero da Organizacao.
    *
    * @return void
    */
    public static function excluiConvocadoPorReuniao($nrreuniao, $nrorg){
        GepConvocadoreuniao::excluiConvocadoReuniao($nrreuniao, $nrorg);
        return true;
    }


    /**
     * Exclui Convocado.
     *
     * @param integer $nrconvocadoreuniao Numero da reuniao.
     * @param integer $nrorg              Numero da Organizacao.
     *
     * @return boolean
    */
    public static function excluiConvocado($nrconvocadoreuniao, $nrorg){
        GepConvocadoreuniao::excluiConvocado($nrconvocadoreuniao, $nrorg);
        return true;
    }


    /**
     * Altera dados do Convocado.
     *
     * @param integer $nratividadegerada Numero da atividade.
     * @param integer $nrorg             Numero da organizacao.
     *
     * @return boolean
     */
    public static function alteraDadosConvocado(
        $nratividadegerada, $nrorg
    ){
        $lista_atividade = GepConvocadoreuniao::getObjectsByWhere(
            ' NRATIVIDADEGERADA = ? AND NRORG = ?',
            array(
             $nratividadegerada,
             $nrorg,
            )
        );

        foreach ($lista_atividade as $ativ) {
            $ativ->setNratividadegerada(null);
            $ativ->persist();
        }

        return true;
    }


    /**
     * Conta quantos parceiros foram convocados para uma reuniao.
     *
     * @param integer $nrorg     Numero da Organizacao.
     * @param integer $nrreuniao Numero da reuniao.
     *
     * @return multitype:|boolean
     */
    public static function consultaQtdParceirosConvocados($nrorg, $nrreuniao){
        $qtd = GepConvocadoreuniao::consultaQtdParceirosConvocados($nrorg, $nrreuniao);
        return $qtd;
    }


    /**
     * Metodo para inserir convocados.
     *
     * @param array $v_fields Dados da tab.
     *
     * @return boolean
     */
    public function insereConvocado(array $v_fields){
        try {
            $cod = GepConvocadoreuniaoEntity::retornaProxNumeroConvocadoreuniao($v_fields['NRORG']);

            $obj = new self;
            $obj->setNrconvocadoreuniao($cod);
            $obj->setIdativo($v_fields['IDATIVO']);
            $obj->setNrreuniao($v_fields['NRREUNIAO']);
            $obj->setIdparticipacao($v_fields['IDPARTICIPACAO']);
            $obj->setNrparcoperador($v_fields['NRPARCOPERADOR']);
            $obj->setNratividadegerada($v_fields['NRATIVIDADEGERADA']);
            $obj->setNmconvocadoreuniao($v_fields['NMCONVOCADOREUNIAO']);
            $obj->setDsemailconvocado($v_fields['DSEMAILCONVOCADO']);
            $obj->setNrorg($v_fields['NRORG']);
            $obj->setDtinclusao($v_fields['DTINCLUSAO']);
            $obj->setCdoperinclusao($v_fields['CDOPERINCLUSAO']);
            $obj->setNrorginclusao($v_fields['NRORGINCLUSAO']);
            $obj->setDtultatu($v_fields['DTULTATU']);
            $obj->setCdoperultatu($v_fields['CDOPERULTATU']);
            $obj->setNrorgultatu($v_fields['NRORGULTATU']);
            $obj->persist();
            return true;

        } catch (Exception $e) {
            showClassError($e, __FUNCTION__, __LINE__);
            return false;
        }
    }


    /**
     * Metodo para verificar se existe atividade apropriada.
     *
     * @param integer $nrorg     Numero da organizacao.
     * @param integer $atividade Numero da atividade.
     *
     * @throws Exception Caso nao esteja apropriado.
     * @return GepConvocadoreuniaoEntity
     */

    public function verificarAtividadeGerada($nrorg, $atividade){
        $dados = GepConvocadoreuniao::verificarAtividadeGerada($nrorg, $atividade);
        if ($dados instanceof GepConvocadoreuniaoEntity) {
            return $dados;
        }

        Throw new Exception('Nenhum registro de atividade foi encontrado.', self::SEM_REGISTRO);
    }


    /**
     * Metodo para remover o NRATIVIDADE.
     *
     * @param integer $nrorg             Numero da organizacao.
     * @param integer $nratividadegerada Numero da atividade.
     *
     * @return boolean
     */
    public function atualizaOperadorByAtividade($nrorg, $nratividadegerada){
        $registro = GepConvocadoreuniao::getObjectByWhere(
            'NRATIVIDADEGERADA = ? AND NRORG = ?',
            array(
             $nratividadegerada,
             $nrorg,
            )
        );

        $registro->setNratividadegerada(null);
        $registro->persist();

        return true;
    }


    /**
     * Consulta total de convocados na sala.
     *
     * @param integer $nrorg Numero da organizacao.
     * @param integer $sala  Numero da sala.
     *
     * @return Ambiguous|boolean
     */
    public function consultaTotalConvocadosSala($nrorg, $sala) {
        $total = GepConvocadoreuniao::consultaTotalConvocadosSala($nrorg, $sala);
        return $total;
    }


    /**
     * Consulta o total de convocados na sala no periodo.
     *
     * @param integer $nrorg    Numero da organizacao.
     * @param integer $sala     Numero da sala.
     * @param string  $dtinicio Data de inicio.
     * @param string  $dtfim    Data de fim.
     *
     * @return integer
     */
    public static function consultaTotalConvocadosSalaPorPeriodo($nrorg, $sala, $dtinicio, $dtfim){
        $qtd = GepConvocadoreuniao::consultaTotalConvocadosSalaPorPeriodo($nrorg, $sala, $dtinicio, $dtfim);
        if (empty($qtd) === false) {
            return $qtd;
        } else {
            return 0;
        }
    }


}